diff --git a/target/linux/archs38/config-5.15 b/target/linux/archs38/config-5.15
index b526c0efe0..9e537951df 100644
--- a/target/linux/archs38/config-5.15
+++ b/target/linux/archs38/config-5.15
@@ -87,7 +87,6 @@ CONFIG_FB=y
 CONFIG_FB_CMDLINE=y
 CONFIG_FIXED_PHY=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/armsr/config-6.1 b/target/linux/armsr/config-6.1
index d1dac69da4..745a5caf9d 100644
--- a/target/linux/armsr/config-6.1
+++ b/target/linux/armsr/config-6.1
@@ -138,7 +138,6 @@ CONFIG_FRAMEBUFFER_CONSOLE_DETECT_PRIMARY=y
 # CONFIG_FRAMEBUFFER_CONSOLE_ROTATION is not set
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
 CONFIG_GENERIC_ARCH_TOPOLOGY=y
diff --git a/target/linux/at91/sam9x/config-5.15 b/target/linux/at91/sam9x/config-5.15
index 2c29ca2369..5a902d5cd1 100644
--- a/target/linux/at91/sam9x/config-5.15
+++ b/target/linux/at91/sam9x/config-5.15
@@ -95,7 +95,6 @@ CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/at91/sama5/config-5.15 b/target/linux/at91/sama5/config-5.15
index 6130e288dd..4cf28c5f33 100644
--- a/target/linux/at91/sama5/config-5.15
+++ b/target/linux/at91/sama5/config-5.15
@@ -163,7 +163,6 @@ CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FORCE_MAX_ZONEORDER=15
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/at91/sama7/config-5.15 b/target/linux/at91/sama7/config-5.15
index 23b74890ea..86187089bf 100644
--- a/target/linux/at91/sama7/config-5.15
+++ b/target/linux/at91/sama7/config-5.15
@@ -150,7 +150,6 @@ CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FORCE_MAX_ZONEORDER=15
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
diff --git a/target/linux/bcm27xx/bcm2708/config-6.1 b/target/linux/bcm27xx/bcm2708/config-6.1
index 244fa67656..913063ef1a 100644
--- a/target/linux/bcm27xx/bcm2708/config-6.1
+++ b/target/linux/bcm27xx/bcm2708/config-6.1
@@ -164,7 +164,6 @@ CONFIG_FRAMEBUFFER_CONSOLE=y
 CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
diff --git a/target/linux/bcm27xx/bcm2709/config-6.1 b/target/linux/bcm27xx/bcm2709/config-6.1
index 7bdde533ab..446a42a967 100644
--- a/target/linux/bcm27xx/bcm2709/config-6.1
+++ b/target/linux/bcm27xx/bcm2709/config-6.1
@@ -201,7 +201,6 @@ CONFIG_FREEZER=y
 CONFIG_FS_ENCRYPTION=y
 CONFIG_FS_ENCRYPTION_ALGS=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
diff --git a/target/linux/bcm27xx/bcm2710/config-6.1 b/target/linux/bcm27xx/bcm2710/config-6.1
index dd2d87d583..0ce37ed741 100644
--- a/target/linux/bcm27xx/bcm2710/config-6.1
+++ b/target/linux/bcm27xx/bcm2710/config-6.1
@@ -211,7 +211,6 @@ CONFIG_FSL_ERRATUM_A008585=y
 CONFIG_FS_ENCRYPTION=y
 CONFIG_FS_ENCRYPTION_ALGS=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
diff --git a/target/linux/bcm27xx/bcm2711/config-6.1 b/target/linux/bcm27xx/bcm2711/config-6.1
index 7313c6447c..883e01ea62 100644
--- a/target/linux/bcm27xx/bcm2711/config-6.1
+++ b/target/linux/bcm27xx/bcm2711/config-6.1
@@ -216,7 +216,6 @@ CONFIG_FSL_ERRATUM_A008585=y
 CONFIG_FS_ENCRYPTION=y
 CONFIG_FS_ENCRYPTION_ALGS=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
diff --git a/target/linux/gemini/config-6.1 b/target/linux/gemini/config-6.1
index cbd3204708..8cc8f72c79 100644
--- a/target/linux/gemini/config-6.1
+++ b/target/linux/gemini/config-6.1
@@ -161,7 +161,6 @@ CONFIG_FRAMEBUFFER_CONSOLE=y
 CONFIG_FRAMEBUFFER_CONSOLE_DETECT_PRIMARY=y
 # CONFIG_FRAMEBUFFER_CONSOLE_ROTATION is not set
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FTTMR010_TIMER=y
 CONFIG_FTWDT010_WATCHDOG=y
diff --git a/target/linux/imx/config-5.15 b/target/linux/imx/config-5.15
index dc57ea0fff..e0b73fd4fc 100644
--- a/target/linux/imx/config-5.15
+++ b/target/linux/imx/config-5.15
@@ -169,7 +169,6 @@ CONFIG_FSL_GUTS=y
 CONFIG_FS_ENCRYPTION=y
 CONFIG_FS_ENCRYPTION_ALGS=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/ixp4xx/config-6.1 b/target/linux/ixp4xx/config-6.1
index 45f017a6f8..a7b14bfb66 100644
--- a/target/linux/ixp4xx/config-6.1
+++ b/target/linux/ixp4xx/config-6.1
@@ -81,7 +81,6 @@ CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FORCE_PCI=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_FW_LOADER_SYSFS=y
diff --git a/target/linux/layerscape/armv7/config-5.15 b/target/linux/layerscape/armv7/config-5.15
index 5af6d8c8bd..8bb9106873 100644
--- a/target/linux/layerscape/armv7/config-5.15
+++ b/target/linux/layerscape/armv7/config-5.15
@@ -214,7 +214,6 @@ CONFIG_FSL_PQ_MDIO=y
 CONFIG_FSL_RCPM=y
 CONFIG_FSL_XGMAC_MDIO=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FTRACE=y
 # CONFIG_FTRACE_SYSCALLS is not set
diff --git a/target/linux/layerscape/armv7/config-6.1 b/target/linux/layerscape/armv7/config-6.1
index 41a8d39ba8..bab44de4c2 100644
--- a/target/linux/layerscape/armv7/config-6.1
+++ b/target/linux/layerscape/armv7/config-6.1
@@ -224,7 +224,6 @@ CONFIG_FSL_PQ_MDIO=y
 CONFIG_FSL_RCPM=y
 CONFIG_FSL_XGMAC_MDIO=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FTRACE=y
 # CONFIG_FTRACE_SYSCALLS is not set
diff --git a/target/linux/layerscape/armv8_64b/config-5.15 b/target/linux/layerscape/armv8_64b/config-5.15
index ba625a9465..f8f8b59c12 100644
--- a/target/linux/layerscape/armv8_64b/config-5.15
+++ b/target/linux/layerscape/armv8_64b/config-5.15
@@ -298,7 +298,6 @@ CONFIG_FSL_MC_UAPI_SUPPORT=y
 CONFIG_FSL_RCPM=y
 CONFIG_FSL_XGMAC_MDIO=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FUSE_FS=y
 CONFIG_FWNODE_MDIO=y
diff --git a/target/linux/layerscape/armv8_64b/config-6.1 b/target/linux/layerscape/armv8_64b/config-6.1
index 2b606c43b0..6db1fc7052 100644
--- a/target/linux/layerscape/armv8_64b/config-6.1
+++ b/target/linux/layerscape/armv8_64b/config-6.1
@@ -318,7 +318,6 @@ CONFIG_FSL_MC_UAPI_SUPPORT=y
 CONFIG_FSL_RCPM=y
 CONFIG_FSL_XGMAC_MDIO=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FUSE_FS=y
 CONFIG_FWNODE_MDIO=y
diff --git a/target/linux/malta/config-5.15 b/target/linux/malta/config-5.15
index 592db8b3a8..480b738b2d 100644
--- a/target/linux/malta/config-5.15
+++ b/target/linux/malta/config-5.15
@@ -70,7 +70,6 @@ CONFIG_DUMMY_CONSOLE=y
 CONFIG_EXT4_FS=y
 CONFIG_F2FS_FS=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ATOMIC64=y
diff --git a/target/linux/malta/config-6.1 b/target/linux/malta/config-6.1
index 85048b6cd0..bb95793072 100644
--- a/target/linux/malta/config-6.1
+++ b/target/linux/malta/config-6.1
@@ -71,7 +71,6 @@ CONFIG_DUMMY_CONSOLE=y
 CONFIG_EXT4_FS=y
 CONFIG_F2FS_FS=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ATOMIC64=y
diff --git a/target/linux/mediatek/filogic/config-5.15 b/target/linux/mediatek/filogic/config-5.15
index 031ae51979..a8f117f2c4 100644
--- a/target/linux/mediatek/filogic/config-5.15
+++ b/target/linux/mediatek/filogic/config-5.15
@@ -135,7 +135,6 @@ CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
diff --git a/target/linux/mediatek/filogic/config-6.1 b/target/linux/mediatek/filogic/config-6.1
index 48322e473a..b41e87e10b 100644
--- a/target/linux/mediatek/filogic/config-6.1
+++ b/target/linux/mediatek/filogic/config-6.1
@@ -150,7 +150,6 @@ CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_FW_LOADER_SYSFS=y
diff --git a/target/linux/mediatek/mt7622/config-5.15 b/target/linux/mediatek/mt7622/config-5.15
index 1d5a799b4c..99a170a2a8 100644
--- a/target/linux/mediatek/mt7622/config-5.15
+++ b/target/linux/mediatek/mt7622/config-5.15
@@ -158,7 +158,6 @@ CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
diff --git a/target/linux/mediatek/mt7622/config-6.1 b/target/linux/mediatek/mt7622/config-6.1
index 73d26c3f2b..26f6d8a1b1 100644
--- a/target/linux/mediatek/mt7622/config-6.1
+++ b/target/linux/mediatek/mt7622/config-6.1
@@ -157,7 +157,6 @@ CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FRAME_POINTER=y
 CONFIG_FRAME_WARN=2048
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_FW_LOADER_SYSFS=y
diff --git a/target/linux/mediatek/mt7623/config-5.15 b/target/linux/mediatek/mt7623/config-5.15
index cb158845ad..e13a67f0b1 100644
--- a/target/linux/mediatek/mt7623/config-5.15
+++ b/target/linux/mediatek/mt7623/config-5.15
@@ -212,7 +212,6 @@ CONFIG_FRAMEBUFFER_CONSOLE_DETECT_PRIMARY=y
 CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/mediatek/mt7623/config-6.1 b/target/linux/mediatek/mt7623/config-6.1
index 63bbbed430..2ff27a1f4c 100644
--- a/target/linux/mediatek/mt7623/config-6.1
+++ b/target/linux/mediatek/mt7623/config-6.1
@@ -226,7 +226,6 @@ CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
 CONFIG_FRAME_WARN=1024
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/mvebu/config-5.15 b/target/linux/mvebu/config-5.15
index 87bb79d25e..8b1c64b6d9 100644
--- a/target/linux/mvebu/config-5.15
+++ b/target/linux/mvebu/config-5.15
@@ -151,7 +151,6 @@ CONFIG_F2FS_FS=y
 CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
diff --git a/target/linux/mvebu/config-6.1 b/target/linux/mvebu/config-6.1
index 56934c807a..b84c3aeef9 100644
--- a/target/linux/mvebu/config-6.1
+++ b/target/linux/mvebu/config-6.1
@@ -157,7 +157,6 @@ CONFIG_F2FS_FS=y
 CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_FW_LOADER_SYSFS=y
diff --git a/target/linux/mxs/config-5.15 b/target/linux/mxs/config-5.15
index 0aa73e1eb3..e98cbb03d5 100644
--- a/target/linux/mxs/config-5.15
+++ b/target/linux/mxs/config-5.15
@@ -80,7 +80,6 @@ CONFIG_FEC=y
 CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
diff --git a/target/linux/mxs/config-6.1 b/target/linux/mxs/config-6.1
index 1f131c4d5f..d8547e9859 100644
--- a/target/linux/mxs/config-6.1
+++ b/target/linux/mxs/config-6.1
@@ -79,7 +79,6 @@ CONFIG_FEC=y
 CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
diff --git a/target/linux/octeon/config-5.15 b/target/linux/octeon/config-5.15
index dbda116622..14d8eafbde 100644
--- a/target/linux/octeon/config-5.15
+++ b/target/linux/octeon/config-5.15
@@ -71,7 +71,6 @@ CONFIG_F2FS_FS=y
 CONFIG_FAT_FS=y
 CONFIG_FIXED_PHY=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
diff --git a/target/linux/omap/config-5.15 b/target/linux/omap/config-5.15
index 98bebfc9b2..aa03d9a05b 100644
--- a/target/linux/omap/config-5.15
+++ b/target/linux/omap/config-5.15
@@ -225,7 +225,6 @@ CONFIG_FHANDLE=y
 CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/oxnas/ox810se/config-default b/target/linux/oxnas/ox810se/config-default
index 5d2d49c288..5d762a1c44 100644
--- a/target/linux/oxnas/ox810se/config-default
+++ b/target/linux/oxnas/ox810se/config-default
@@ -4,5 +4,4 @@ CONFIG_CPU_IDLE_GOV_MENU=y
 CONFIG_CPU_IDLE_MULTIPLE_DRIVERS=y
 # CONFIG_DEBUG_UNCOMPRESS is not set
 CONFIG_EXT4_FS=y
-CONFIG_FS_MBCACHE=y
 CONFIG_MACH_OX810SE=y
diff --git a/target/linux/pistachio/config-5.15 b/target/linux/pistachio/config-5.15
index db6d91ac9c..be5b622b49 100644
--- a/target/linux/pistachio/config-5.15
+++ b/target/linux/pistachio/config-5.15
@@ -81,7 +81,6 @@ CONFIG_FIT_IMAGE_FDT_MARDUK=y
 # CONFIG_FIT_IMAGE_FDT_XILFPGA is not set
 CONFIG_FIXED_PHY=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/qoriq/config-5.15 b/target/linux/qoriq/config-5.15
index 9d909672b3..90fa61cf37 100644
--- a/target/linux/qoriq/config-5.15
+++ b/target/linux/qoriq/config-5.15
@@ -131,7 +131,6 @@ CONFIG_FSL_SOC=y
 CONFIG_FSL_SOC_BOOKE=y
 CONFIG_FSL_XGMAC_MDIO=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FTL=y
 CONFIG_FUNCTION_ERROR_INJECTION=y
diff --git a/target/linux/rockchip/armv8/config-5.15 b/target/linux/rockchip/armv8/config-5.15
index 61539d922c..042f22b395 100644
--- a/target/linux/rockchip/armv8/config-5.15
+++ b/target/linux/rockchip/armv8/config-5.15
@@ -202,7 +202,6 @@ CONFIG_FIX_EARLYCON_MEM=y
 # CONFIG_FORTIFY_SOURCE is not set
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/rockchip/armv8/config-6.1 b/target/linux/rockchip/armv8/config-6.1
index dd9f7da98c..04a76b363a 100644
--- a/target/linux/rockchip/armv8/config-6.1
+++ b/target/linux/rockchip/armv8/config-6.1
@@ -227,7 +227,6 @@ CONFIG_FIX_EARLYCON_MEM=y
 # CONFIG_FORTIFY_SOURCE is not set
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
diff --git a/target/linux/sifiveu/config-6.1 b/target/linux/sifiveu/config-6.1
index f3474f13b8..63c34ee0f2 100644
--- a/target/linux/sifiveu/config-6.1
+++ b/target/linux/sifiveu/config-6.1
@@ -100,7 +100,6 @@ CONFIG_FONT_SUPPORT=y
 CONFIG_FPU=y
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_FW_LOADER_SYSFS=y
diff --git a/target/linux/sunxi/config-5.15 b/target/linux/sunxi/config-5.15
index daadef4283..cd702a4f43 100644
--- a/target/linux/sunxi/config-5.15
+++ b/target/linux/sunxi/config-5.15
@@ -163,7 +163,6 @@ CONFIG_FRAMEBUFFER_CONSOLE_DETECT_PRIMARY=y
 CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
diff --git a/target/linux/sunxi/config-6.1 b/target/linux/sunxi/config-6.1
index 5af7ff7a66..43cbacc5e8 100644
--- a/target/linux/sunxi/config-6.1
+++ b/target/linux/sunxi/config-6.1
@@ -167,7 +167,6 @@ CONFIG_FRAMEBUFFER_CONSOLE_ROTATION=y
 CONFIG_FRAME_WARN=2048
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FS_POSIX_ACL=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
diff --git a/target/linux/tegra/config-5.15 b/target/linux/tegra/config-5.15
index 3af9175721..bf6c6cc8d4 100644
--- a/target/linux/tegra/config-5.15
+++ b/target/linux/tegra/config-5.15
@@ -185,7 +185,6 @@ CONFIG_FB_SYS_FOPS=y
 CONFIG_FB_SYS_IMAGEBLIT=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_ALLOCATOR=y
 CONFIG_GENERIC_ARCH_TOPOLOGY=y
diff --git a/target/linux/uml/config-5.15 b/target/linux/uml/config-5.15
index 82cf4e9143..32154633a4 100644
--- a/target/linux/uml/config-5.15
+++ b/target/linux/uml/config-5.15
@@ -36,7 +36,6 @@ CONFIG_EXT4_FS=y
 CONFIG_F2FS_FS=y
 CONFIG_FAILOVER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_GENERIC_CLOCKEVENTS=y
 # CONFIG_GENERIC_CPU is not set
diff --git a/target/linux/uml/config-6.1 b/target/linux/uml/config-6.1
index 94e4c90a9e..1c2dd5faae 100644
--- a/target/linux/uml/config-6.1
+++ b/target/linux/uml/config-6.1
@@ -39,7 +39,6 @@ CONFIG_EXT4_FS=y
 CONFIG_F2FS_FS=y
 CONFIG_FAILOVER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y
 CONFIG_FW_LOADER_SYSFS=y
 CONFIG_GCC11_NO_ARRAY_BOUNDS=y
diff --git a/target/linux/x86/config-5.15 b/target/linux/x86/config-5.15
index d7ddca845b..57941a53bf 100644
--- a/target/linux/x86/config-5.15
+++ b/target/linux/x86/config-5.15
@@ -110,7 +110,6 @@ CONFIG_FIRMWARE_MEMMAP=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FUSION=y
 # CONFIG_FUSION_CTL is not set
 # CONFIG_FUSION_LOGGING is not set
diff --git a/target/linux/x86/config-6.1 b/target/linux/x86/config-6.1
index 07d6f8bc35..979bb400c1 100644
--- a/target/linux/x86/config-6.1
+++ b/target/linux/x86/config-6.1
@@ -118,7 +118,6 @@ CONFIG_FIRMWARE_MEMMAP=y
 CONFIG_FIX_EARLYCON_MEM=y
 CONFIG_FRAME_POINTER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FUSION=y
 # CONFIG_FUSION_CTL is not set
 # CONFIG_FUSION_LOGGING is not set
diff --git a/target/linux/zynq/config-5.15 b/target/linux/zynq/config-5.15
index 60ba49a5f9..a227618357 100644
--- a/target/linux/zynq/config-5.15
+++ b/target/linux/zynq/config-5.15
@@ -181,7 +181,6 @@ CONFIG_FPGA_MGR_ZYNQ_FPGA=y
 CONFIG_FPGA_REGION=y
 CONFIG_FREEZER=y
 CONFIG_FS_IOMAP=y
-CONFIG_FS_MBCACHE=y
 CONFIG_FWNODE_MDIO=y
 CONFIG_FW_CACHE=y
 CONFIG_FW_LOADER_PAGED_BUF=y